ArrayList<Ball> balls = new ArrayList<Ball>(); //declare a ArrayList of custom objects of type Ball
Paddle paddle; //declare a custom object of type Paddle

int points = 0;
boolean gameOver = false;

void setup()
{
  size(800, 600);
  
  //when using objects we must use "new" to allocate space and call their constructors
  //This loop is optional for ArrayList, only if we want an initial number of objects
  //for(int i = 0; i < balls.size(); i++)
  //{
  //  balls.add(new Ball()); 
  //}
  
  paddle = new Paddle(20, 100);
  
  textSize(64);
}

void draw()
{
  background(0);
  
  /////////////////////////////////////////////////////////////////////////////////
  //Text Display
  if(gameOver)
    text("GAME OVER!!!!!", 0, 50);
  else
    text(points, 0, 50);
  
  /////////////////////////////////////////////////////////////////////////////////
  //Update and Draw Paddle
  paddle.update(); //update movement - this is a custom function, can be called anything
  paddle.display(); //drawing code for paddle - can be called anything except "draw"
  
  /////////////////////////////////////////////////////////////////////////////////
  //Update and Draw all the balls
  for(int i = 0; i < balls.size(); i++)
  {
    balls.get(i).update(); //update movement
    balls.get(i).display(); //draw ball
  
    //Check if the ball is hit by the paddle
    float ballLeft = balls.get(i).x - balls.get(i).size/2;
    boolean isHit = paddle.hit(ballLeft, balls.get(i).y);
    if(isHit)
    {
     //println("HIT!!!!!");
     balls.get(i).xDir *= -1;
     //ball.size += 20; //increase the size with each hit
     //ball.x = paddle.x + paddle.w + ball.size/2; //fix the bounds with each hit
     //ball.speed += 5; //increase the speed with each hit
     
     //add points
     points++;
    } 
  } //end of the balls loop
  
  /////////////////////////////////////////////////////////////////////////////////
  //Figure out if the game is over
  boolean isOver = true;
  for(int i = 0; i < balls.size(); i++)
  {
    if(balls.get(i).x > 0)
    {
      isOver = false; 
    }
  }
  gameOver = isOver;
  if(gameOver)
  {
   points = 0; 
  }
  
}

void keyPressed()
{
  if(key == 'a')
    balls.add(new Ball());
  else if(key == 'r')
    balls.remove(0); //remove first in list, try remove(balls.size()-1) to remove last
  else if(key == 'c')
    balls.clear();
}

void mouseClicked()
{
  if(gameOver)
  {
    for(int i = 0; i < balls.size(); i++)
    {
      balls.get(i).reset();
    }
    gameOver = false;
  }
}